// FunktionsBerechner.java                          MM 2013
import Tools.IO.*;                              // Eingaben

/**
 * Programm zum Berechnen von Funktionswerten.
 * @author Monika Meiler
 */
public class FunktionsBerechner
{
/* ----------------------------------------------------- */
                                                // Attribut
/**
 * Speichert Differenzierbarkeit.
 */
  private boolean differenzierbar = true;

/* ----------------------------------------------------- */
                                                  // Dialog
/**
 * Funktionsberechner:
 * Funktionseingabe, Wertberechnung.
 */
  public void dialog()
  {
// Ueberschrift
    System.out.println();
    System.out.println( "Funktionsberechner");

// Dialog
    char weiter = 'j';
    do
    {
// Neue Funktion
      Funktion fkt = funktionsAuswahl();
      if( fkt == null) continue;
      if( fkt.konsolenEingabe())         // Eingabe korrekt
      {

// Funktionsausgabe
        System.out.println();
        System.out.println( "f( x) = " + fkt);

        do
        {
// Werteberechnug
          System.out.println();
          berechneWert( fkt);

// Weiter
          System.out.println();
          weiter = IOTools.readChar( "Neuer Wert (j/n)? ");
        } while( weiter == 'j');

      }
      weiter = IOTools.readChar( "Neue Funktion (j/n)? ");
    } while( weiter == 'j');

// Programm beendet
    System.out.println();
    System.out.println( "Programm beendet");
  }

/* ----------------------------------------------------- */
                                                // Funktion
/**
 * Funktionsauswahl.
 * @return Funktion
 */
  private Funktion funktionsAuswahl()
  {
// Menue aller Funktionen
    System.out.println( "Funktionsauswahl");
    System.out.println
    ( "  Gerade                      ...  1");
    System.out.println
    ( "  Polynom                     ...  2");
    System.out.println
    ( "  Wurzel-Funktion             ...  3");
    System.out.println
    ( "  e^x - Funktion              ...  4");
    System.out.println
    ( "  a^x-Funktion                ...  5");
    System.out.println
    ( "  sin-Funktion                ...  6");
    System.out.println
    ( "  cos-Funktion                ...  7");
    System.out.println
    ( "  tan-Funktion                ...  8");
    System.out.println
    ( "  cot-Funktion                ...  9");
    System.out.println
    ( "  arctan-Funktion             ... 10");
    System.out.println
    ( "  ln-Funktion                 ... 11");
    System.out.println
    ( "  log-Funktion                ... 12");
    System.out.print
    ( "  gebrochenrationale Funktion ... 13");

    int eingabe = IOTools.readInteger(": ");

// Festlegen der Funktion
    Funktion fkt = null;
    differenzierbar = true;

    switch( eingabe)
    {
      case 1: fkt = new Gerade(); break;
      case 2: fkt = new Polynom( ); break;
      case 3: fkt = new Wurzel(); break;
      case 4: fkt = new Exp(); break;
      case 5: fkt = new Power(); break;
      case 6: fkt = new Sinus(); break;
      case 7: fkt = new Cosinus( ); break;
      case 8: fkt = new Tangens(); break;
      case 9: fkt = new Cotangens(); break;
      case 10: fkt = new Arctan(); break;
      case 11: fkt = new Ln(); break;
      case 12: fkt = new LogB(); break;
      case 13: differenzierbar = false;
               fkt = new RationaleFunktion(); break;
      default: System.out.println();
        System.out.println( "Fehlerhafte Eingabe!");
    }

    return fkt;
  }

/* ----------------------------------------------------- */
                                               // Berechnen
/**
 * Berechnen einer Funktion und deren 1. Ableitung
 * an einer Stlle x0.
 * @param fkt Funktion
 */
  private void berechneWert( Funktion fkt)
  {
// Argumenteingabe
    System.out.println( "Wertberechnung");
    double x0 = IOTools.readDouble( " x0 = ");
    System.out.println( x0);

// Wertberechnung 
    double y0 = fkt.wert( x0);

// Ausgabe
    System.out.print( " f( " + x0 + ") = " + y0);

// Wertberechnung 1. Ableitung
    if( differenzierbar)
    {
      DifferenzierbareFunktion dfkt
      = (DifferenzierbareFunktion)fkt;
      double y1 = dfkt.wertErsteAbleitung( x0);
      System.out.println( "\t\tf'( " + x0 + ") = " + y1);
    }
  }

/* ----------------------------------------------------- */
                                                // Programm
/**
 * Hauptprogramm, startet Funktionsberechnung.
 */
  public static void main( String[] args)
  {
// Berechner erzeugen
    FunktionsBerechner berechner
    = new FunktionsBerechner();

// Berechner starten
    berechner.dialog();
  }
}

/* ----------------------------------------------------- */
                                           // Testbeispiele
/*
f( x) = 
-9.0 + 3.0 x^1 + -5.0 x^2 + 0.0 x^3 + -1.0 x^4 + 2.0 x^5

f( 3.0) = 360.0		f'( 3.0) = 675.0

f( x) = 
-1.0 + 1.0 x^1 + 1.0 x^2 + 3.0 x^3 + 0.0 x^4 +
-2.0 x^5 + 1.0 x^6

f( -1.0) = -1.0		f'( -1.0) = -8.0
f( 1.0) = 3.0		f'( 1.0) = 8.0

f( x) = 
( -6.0 + 3.0 x^1 ) / ( 2.0 + -3.0 x^1 + 0.0 x^2 + 1.0 x^3 )

f( -3.0) = 0.9375
f( -2.0) = -Infinity
f( -1.0) = -2.25
f( 0.0) = -3.0
f( 1.0) = -Infinity
f( 2.0) = 0.0
f( 3.0) = 0.15
*/
