// FunktionsIntegrator.java                         MM 2013
import Tools.IO.*;                              // Eingaben

/**
 * Programm zur Integrieren von Funktionen.
 * @author Monika Meiler
 */
public class FunktionsIntegrator
{
/* ----------------------------------------------------- */
                                                  // Dialog
/**
 * Funktionsberechner:
 * Funktionseingabe, Wertberechnung.
 */
  public void dialog()
  {
// Ueberschrift
    System.out.println();
    System.out.println( "Funktionsintegrator");

// Dialog
    char weiter = 'j';
    do
    {
// Neue Funktion
      Funktion fkt = funktionsAuswahl();
      if( fkt == null) continue;
      if( fkt.konsolenEingabe())         // Eingabe korrekt
      {

// Funktionsausgabe
        System.out.println();
        System.out.println( "Integral von " +  fkt);

        do
        {
// Integralberechnug
          System.out.println();
          berechneIntegral( fkt);

// Weiter
          System.out.println();
          weiter = IOTools.readChar( "Neues Integral (j/n)? ");
        } while( weiter == 'j');

      }
      weiter = IOTools.readChar( "Neue Funktion (j/n)? ");
    } while( weiter == 'j');

// Programm beendet
    System.out.println();
    System.out.println( "Programm beendet");
  }

/* ----------------------------------------------------- */
                                                // Funktion
/**
 * Funktionsauswahl.
 * @return Funktion
 */
  private Funktion funktionsAuswahl()
  {
// Menue aller Funktionen
    System.out.println( "Funktionsauswahl");
    System.out.println
    ( "  Gerade                      ...  1");
    System.out.println
    ( "  Polynom                     ...  2");
    System.out.println
    ( "  Wurzel-Funktion             ...  3");
    System.out.println
    ( "  e^x - Funktion              ...  4");
    System.out.println
    ( "  a^x-Funktion                ...  5");
    System.out.println
    ( "  sin-Funktion                ...  6");
    System.out.println
    ( "  cos-Funktion                ...  7");
    System.out.println
    ( "  tan-Funktion                ...  8");
    System.out.println
    ( "  cot-Funktion                ...  9");
    System.out.println
    ( "  arctan-Funktion             ... 10");
    System.out.println
    ( "  ln-Funktion                 ... 11");
    System.out.print
    ( "  log-Funktion                ... 12");

    int eingabe = IOTools.readInteger(": ");

// Festlegen der Funktion
    Funktion fkt = null;
    switch( eingabe)
    {
      case 1: fkt = new Gerade(); break;
      case 2: fkt = new Polynom( ); break;
      case 3: fkt = new Wurzel(); break;
      case 4: fkt = new Exp(); break;
      case 5: fkt = new Power(); break;
      case 6: fkt = new Sinus(); break;
      case 7: fkt = new Cosinus( ); break;
      case 8: fkt = new Tangens(); break;
      case 9: fkt = new Cotangens(); break;
      case 10: fkt = new Arctan(); break;
      case 11: fkt = new Ln(); break;
      case 12: fkt = new LogB(); break;
      default: System.out.println();
        System.out.println( "Fehlerhafte Eingabe!");
    }

    return fkt;
  }

/* ----------------------------------------------------- */
                                             // Integrieren
/**
 * Integralberechnung.
 * @param fkt Funktion
 */
  private void berechneIntegral( Funktion fkt)
  {
// Eingabe der Integralparameter
    double a, b;
    do
    {
      a = IOTools.readDouble( " Untere Grenze a = ");
      System.out.println( a);
      b = IOTools.readDouble( " Obere  Grenze b = ");
      System.out.println( b);
    } while( a >= b);

// Eingaben der Stuetzstellen
    int s;
    do
    {
      System.out.print( " Anzahl der Stuetzstellen s > 1, ");
      s = IOTools.readInteger( "s = ");
      System.out.println( s);
    } while( s < 2);

// Integral
    Integral integral = new Integral();

// Trapez Integralberechnung
    double ergTrapez = integral.trapez( fkt, a, b, s);
    System.out.println( " Trapez:  F = " + ergTrapez);

// Simpson Integralberechnung
    if( s % 2 != 0)
    {
      double ergSimpson = integral.simpson( fkt, a, b, s);
      System.out.println( " Simpson: F = " + ergSimpson);
    }
  }

/* ----------------------------------------------------- */
                                                // Programm
/**
 * Hauptprogramm, startet Integration von Funktionen.
 */
  public static void main( String[] args)
  {
// Integrator erzeugen
    FunktionsIntegrator integrator
    = new FunktionsIntegrator();

// Integrator starten
    integrator.dialog();
  }
}

/* ----------------------------------------------------- */
                                               // Testwerte
/*
Integral von
-1.0 + 1.0 x^1 + 1.0 x^2 + 3.0 x^3 + 0.0 x^4 +
-2.0 x^5 + 1.0 x^6

 Untere Grenze a = -2.0
 Obere  Grenze b = 2.0
 Anzahl der Stuetzstellen s > 1, s = 3
 Trapez:  F = 132.0
 Simpson: F = 86.66666666666666

 Untere Grenze a = -2.0
 Obere  Grenze b = 2.0
 Anzahl der Stuetzstellen s > 1, s = 9
 Trapez:  F = 45.90625
 Simpson: F = 38.541666666666664

 Untere Grenze a = -2.0
 Obere  Grenze b = 2.0
 Anzahl der Stuetzstellen s > 1, s = 15
 Trapez:  F = 40.55371000664203
 Simpson: F = 37.974807225204586

 Untere Grenze a = -2.0
 Obere  Grenze b = 2.0
 Anzahl der Stuetzstellen s > 1, s = 21
 Trapez:  F = 39.207167999999996
 Simpson: F = 37.92170666666665

Mathe: F = 37,904761904761904761904761904762
*/
