// FunktionsTabulator.java                          MM 2013
import Tools.IO.*;                              // Eingaben

/**
 * Programm zum Tabellieren von Funktionen.
 * @author Monika Meiler
 */
public class FunktionsTabulator
{
/* ----------------------------------------------------- */
                                                  // Dialog
/**
 * Funktionstabulator:
 * Funktionseingabe, Wertetabelle.
 */
  public void dialog()
  {
// Ueberschrift
    System.out.println();
    System.out.println( "Funktionstabulator");

// Dialog
    char weiter = 'j';
    do
    {
// Neue Funktion
      Funktion fkt = funktionsAuswahl();
      if( fkt == null) continue;
      if( fkt.konsolenEingabe())         // Eingabe korrekt
      {

// Funktionsausgabe
        System.out.println();
        System.out.println( "f( x) = " + fkt);

        do
        {
// Wertetabelle
          System.out.println();
          erzeugeTabelle( fkt);

// Weiter
          System.out.println();
          weiter = IOTools.readChar( "Neue Tabelle (j/n)? ");
        } while( weiter == 'j');

      }
      weiter = IOTools.readChar( "Neue Funktion (j/n)? ");
    } while( weiter == 'j');

// Programm beendet
    System.out.println();
    System.out.println( "Programm beendet");
  }

/* ----------------------------------------------------- */
                                                // Funktion
/**
 * Funktionsauswahl.
 * @return Funktion
 */
  private Funktion funktionsAuswahl()
  {
// Menue aller Funktionen
    System.out.println( "Funktionsauswahl");
    System.out.println
    ( "  Gerade                      ...  1");
    System.out.println
    ( "  Polynom                     ...  2");
    System.out.println
    ( "  Wurzel-Funktion             ...  3");
    System.out.println
    ( "  e^x - Funktion              ...  4");
    System.out.println
    ( "  a^x-Funktion                ...  5");
    System.out.println
    ( "  sin-Funktion                ...  6");
    System.out.println
    ( "  cos-Funktion                ...  7");
    System.out.println
    ( "  tan-Funktion                ...  8");
    System.out.println
    ( "  cot-Funktion                ...  9");
    System.out.println
    ( "  arctan-Funktion             ... 10");
    System.out.println
    ( "  ln-Funktion                 ... 11");
    System.out.println
    ( "  log-Funktion                ... 12");
    System.out.print
    ( "  gebrochenrationale Funktion ... 13");

    int eingabe = IOTools.readInteger(": ");

// Festlegen der Funktion
    Funktion fkt = null;
    switch( eingabe)
    {
      case 1: fkt = new Gerade(); break;
      case 2: fkt = new Polynom( ); break;
      case 3: fkt = new Wurzel(); break;
      case 4: fkt = new Exp(); break;
      case 5: fkt = new Power(); break;
      case 6: fkt = new Sinus(); break;
      case 7: fkt = new Cosinus( ); break;
      case 8: fkt = new Tangens(); break;
      case 9: fkt = new Cotangens(); break;
      case 10: fkt = new Arctan(); break;
      case 11: fkt = new Ln(); break;
      case 12: fkt = new LogB(); break;
      case 13: fkt = new RationaleFunktion(); break;
      default: System.out.println();
        System.out.println( "Fehlerhafte Eingabe!");
    }

    return fkt;
  }

/* ----------------------------------------------------- */
                                             // Tabellieren
/**
 * Erzeugen und Ausgeben einer Wetetabelle.
 * @param fkt Funktion
 */
  private void erzeugeTabelle( Funktion fkt)
  {
// Eingabe der Tabellenparameter
    System.out.println( "Wertbereich");

    double x0 = IOTools.readDouble( " Startargument x0 = ");
    System.out.println( x0);

    int n = 1;
    do
    {
      n = IOTools.readInteger( " Anzahl n (n > 0) = ");
    } while( n < 1);
    System.out.println( n);

    double h = IOTools.readDouble( " Schrittweite h = ");
    System.out.println( h);

// Wertetabelle
    double[] tabelle = fkt.tabellieren( x0, n, h);

// Tabellenausgabe
    double x = x0;
    for( int i = 0; i < tabelle.length; i++)
    {
      System.out.println
      ( " f( " + x + ")\t= " + tabelle[ i]);
      x += h;
    }
  }


/* ----------------------------------------------------- */
                                                // Programm
/**
 * Hauptprogramm, startet Tabellieren von Funktionen.
 */
  public static void main( String[] args)
  {
// Tabulator erzeugen
    FunktionsTabulator tabulator = new FunktionsTabulator();

// Tabulator starten
    tabulator.dialog();
  }
}

/* ----------------------------------------------------- */
                                            // Testbeispiel
/*
f( x) =
-9.0 + 3.0 x^1 + -5.0 x^2 + 0.0 x^3 + -1.0 x^4 + 2.0 x^5
  Startargument x0 = 0.0
  Anzahl n (n > 0) = 11
  Schrittweite h   = 1.0
  f( 0.0)	= -9.0
  f( 1.0)	= -10.0
  f( 2.0)	= 25.0
  f( 3.0)	= 360.0
  f( 4.0)	= 1715.0
  f( 5.0)	= 5506.0
  f( 6.0)	= 14085.0
  f( 7.0)	= 30980.0
  f( 8.0)	= 61135.0
  f( 9.0)	= 111150.0

f( x) =
-1.0 + 1.0 x^1 + 1.0 x^2 + 3.0 x^3 + 0.0 x^4 +
-2.0 x^5 + 1.0 x^6
  Startargument x0 = -1.0
  Anzahl n (n > 0) = 5
  Schrittweite h   = 0.5
  f( -1.0)	= -1.0
  f( -0.5)	= -1.546875
  f( 0.0)	= -1.0
  f( 0.5)	= 0.078125
  f( 1.0)	= 3.0

f( x) =
( -6.0 + 3.0 x^1 ) / ( 2.0 + -3.0 x^1 + 0.0 x^2 + 1.0 x^3 )
  Startargument x0 = -3.0
  Anzahl n (n > 0) = 7
  Schrittweite h   = 1.0
  f( -3.0)	= 0.9375
  f( -2.0)	= -Infinity
  f( -1.0)	= -2.25
  f( 0.0)	= -3.0
  f( 1.0)	= -Infinity
  f( 2.0)	= 0.0
  f( 3.0)	= 0.15
*/
