// Cosinus.java                                     MM 2013

/**
 * Cosinusfunktion f(x) = cos( x),
 * D = R, W = [ 1, -1].
 * @author Monika Meiler
 */
public class Cosinus extends DifferenzierbareFunktion
{
/* ----------------------------------------------------- */
                                         // service-Methode
/**
 * Berechnen eines Funktionswertes durch
 * Phasenverschiebuung: cos( x) = sin( PI/2 + x).
 * @param arg Argument
 * @return cos( arg)
 */
  public double wert( double arg)
  {
    Sinus sin = new Sinus();
    return sin.wert( Math.PI/2 + arg);
  }

/**
 * Berechnen der ersten Ableitung f'(x) = -sin( x).
 * @param arg Argument
 * @return f'( arg)
 */
  public double wertErsteAbleitung( double arg)
  {
    Sinus sin = new Sinus();
    return -sin.wert( arg);
  }

/* ----------------------------------------------------- */
                                        // toString-Methode
/**
 * Darstellen der Cosinusfunktion.
 * @return Funktion in linearer Schreibweise
 */
  public String toString()
  {
    return "cos( x)";
  }
}