// Cotangens.java                                   MM 2013

/**
 * Cotangensfunktion f(x) = cot( x),
 * D = R \ { x | x = n*PI, n aus N }, W = R.
 * @author Monika Meiler
 */
public class Cotangens extends DifferenzierbareFunktion
{
/* ----------------------------------------------------- */
                                         // service-Methode
/**
 * Berechnen eines Funktionswertes durch
 * cot( x) = cos( x) / sin( x).
 * @param arg Argument
 * @return cot( arg)
 */
  public double wert( double arg)
  {
    Sinus sin = new Sinus();
    Cosinus cos = new Cosinus();

    return cos.wert( arg) / sin.wert( arg);
  }

/**
 * Berechnen der ersten Ableitung
 * f'(x) = - 1 / (sin( x) * sin( x)).
 * @param arg Argument
 * @return f'( arg)
 */
  public double wertErsteAbleitung( double arg)
  {
    Sinus sin = new Sinus();
    double wert = sin.wert( arg);

    return - 1 / (wert * wert);
  }

/* ----------------------------------------------------- */
                                        // toString-Methode
/**
 * Darstellen der Cotangensfunktion.
 * @return Funktion in linearer Schreibweise
 */
  public String toString()
  {
    return "cot( x)";
  }
}