// PolynomTabulator.java                            MM 2013
import Tools.IO.*;                              // Eingaben

/**
 * Tabelliert Polynome.
 * @author Monika Meiler
 */
public class PolynomTabulator
{
/**
 * Polynomtabulator:
 * Polynomeingabe, Eingabe der Tabellenparyameter,
 * Berechnen und Ausgabe der Tabelle.
 */
  public static void main( String[] args)
  {
// Ueberschrift
    System.out.println();
    System.out.println( "Polynomtabulator");

// Dialog
    char weiter = 'j';
    do
    {
// Neues Polynom
      System.out.println();
      Polynom p = new Polynom();
      if( p.konsolenEingabe())           // Eingabe korrekt
      {
// Polynomausgabe
        System.out.println();
        System.out.println( "p( x) = " + p);

        do
        {
// Eingabe der Tabellenparameter
          System.out.println();
          System.out.println( "Wertbereich");

          double x0
          = IOTools.readDouble( " Startargument x0 = ");
          int n
          = IOTools.readInteger( " Anzahl n (n > 0) = ");
          double h = 0;
          if( n > 1)
          h = IOTools.readDouble( " Schrittweite h   = ");

// Wertetabelle
          double[] tabelle = p.tabellieren( x0, n, h);

// Tabellenausgabe
          double arg = x0;
          for( int i = 0; i < tabelle.length; i++)
          {
            System.out.println
            ( " p( " + arg + ")\t= " + tabelle[ i]);
            arg += h;
          }

          System.out.println();

// Weiter
          weiter = IOTools.readChar( "Neue Tabelle (j/n)? ");
        } while( weiter == 'j');
      }

      weiter = IOTools.readChar( "Neues Polynom (j/n)? ");
    } while( weiter == 'j');

// Programm beendet
    System.out.println();
    System.out.println( "Programm beendet");
  }
}

/* ----------------------------------------------------- */
                                            // Testbeispiel
/*
p( x) = 
8.0 + 4.0 x^1 + -10.0 x^2 + -5.0 x^3 + 2.0 x^4 + 1.0 x^5
Wertbereich
 Startargument x0 =  -2.5
 Anzahl n (n > 0) =  11
 Schrittweite h   =  0.5
 p( -2.5)	= -5.90625
 p( -2.0)	= 0.0
 p( -1.5)	= -1.09375
 p( -1.0)	= 0.0
 p( -0.5)	= 4.21875
 p( 0.0)	= 8.0
 p( 0.5)	= 7.03125
 p( 1.0)	= 0.0
 p( 1.5)	= -7.65625
 p( 2.0)	= 0.0
 p( 2.5)	= 53.15625

Programm beendet
*/
