// Gerade.java                                      MM 2013
import Tools.IO.*;                              // Eingaben

/**
 * Geradenfunktion g( x) = mx + n, D = W = R.
 * @author Monika Meiler
 */
public class Gerade extends DifferenzierbareFunktion
{
/* ----------------------------------------------------- */
                                               // Attribute
/**
 * Anstieg m.
 */
  private double m = 0;

/**
 * Absolutglied n.
 */
  private double n = 0;

/* ----------------------------------------------------- */
                                            // set-Methoden
/**
 * Setzt Koeffizienten m und n.
 * @param anstieg Anstieg
 * @param absolut Absolutglied
 * @return true, bei erfolgreichem Eintrag
 */
  public boolean setGerade( double anstieg, double absolut)
  {
    m = anstieg;
    n = absolut;

    return true;
  }

/**
 * Setzt Koeffizienten m und n
 * mittels Punktrichtungsgleichung.
 * @param anstieg Anstieg
 * @param x0 x-Kooerdinate eines Punktes
 * @param y0 y-Kooerdinate eines Punktes
 * @return true, bei erfolgreichem Eintrag
 */
  public boolean setGerade
  ( double anstieg, double x0, double y0)
  {
    m = anstieg;
    n = y0 - m * x0;

    return true;
  }

/**
 * Setzt Koeffizienten m und n, m <> n,
 * mittels Zweipunktegleichung.
 * Liegen die Punkte senkrecht zur x-Achse ( x1 == x2)
 * so ist der Anstieg unendlich und die Gearade laesst
 * sich nicht in dieser Form darstellen.
 * @param x1 x-Kooerdinate eines Punktes
 * @param y1 y-Kooerdinate eines Punktes
 * @param x2 x-Kooerdinate eines zweiten Punktes
 * @param y2 y-Kooerdinate eines zweiten Punktes
 * @return true, bei erfolgreichem Eintrag
 *         false, x1 == x2
 */
  public boolean setGerade
  ( double x1, double y1, double x2, double y2)
  {
    if( x1 == x2) return false;

    m = ( y2 - y1) / ( x2 - x1);
    n = y1 - m * x1;

    return true;
  }

/**
 * Geradeneingabe ueber Konsole.
 * @return true, bei erfolgreicher Eingabe
 */
  public boolean konsolenEingabe()
  {
// Eingabe der Geradenkoeffizienten
    double anstieg
    = IOTools.readDouble( " Anstieg      m = ");
    double absolut
    = IOTools.readDouble( " Absolutglied n = ");

// Setzen der Geradenkoeffizienten
    return setGerade( anstieg, absolut);
  }

/* ----------------------------------------------------- */
                                        // service-Methoden
/**
 * Berechnen eines Funktionswertes.
 * @param arg Argument
 * @return g( arg)
 */
  public double wert( double arg)
  {
    return m * arg + n;
  }

/**
 * Berechnen einer ersten Ableitung g'( x) = m.
 * @param arg Argument
 * @return g'( arg)
 */
  public double wertErsteAbleitung( double arg)
  {
    return m;
  }

/* ----------------------------------------------------- */
                                        // toString-Methode
/**
 * Darstellen einer Geraden.
 * @return Funktion in linearer Schreibweise
 */
  public String toString()
  {
    return m + "x + " + n;
  }
}