// Ln.java                                          MM 2013

/**
 * Logarithmusfunktion, f(x) = ln( x), Basis e,
 * D = ] 0, +unendlich[, W = R.
 * @author Monika Meiler
 */
public class Ln extends DifferenzierbareFunktion
{
/* ----------------------------------------------------- */
                                         // service-Methode
/**
 * Berechnen des Funktionswertes.
 * @param arg Argument
 * @return ln( arg)
 */
  public double wert( double arg)
  {
// Trivialfaelle
    if( arg < 0)  return Double.NaN;
    if( arg == 0) return Double.NEGATIVE_INFINITY;
    if( arg == 1) return 0;

// Newtoniteration
    return myLn( arg);
  }

/**
 * Berechnen eines Funktionswertes als Nullstelle der
 * Umkehrfunktion e ^ x - arg mittels Newton.
 * @param arg Argument
 * @return ln( arg)
 */
  private double myLn( double arg)
  {
    Iteration it = new Iteration();
    Exp exp = new Exp();
    return it.newton_1( exp, arg, 1e-15, 1000);
  }

/**
 * Berechnen der ersten Ableitung f'(x) = 1 / x.
 * @param arg Argument
 * @return f'( arg)
 */
  public double wertErsteAbleitung( double arg)
  {
// Trivialfall
    if( arg == 0) return Double.POSITIVE_INFINITY;

// Sonst
    return 1 / arg;
  }

/* ----------------------------------------------------- */
                                        // toString-Methode
/**
 * Darstellen der Funktion ln.
 * @return Funktion in linearer Schreibweise
 */
  public String toString()
  {
    return "ln( x)";
  }
}