// LnTest.java                                      MM 2013

/**
 * Test der Klasse Ln.
 * @author Monika Meiler
 */
public class LnTest
{
/**
 * Berechnet die Funktion f( x) = ln( x) fuer
 * gegebene x, vergleicht Ergebnis mit Math.log( x).
 */
  public static void main( String[] args)
  {
// Logarithmusfunktion
    Ln ln = new Ln();

// Funktionsausgabe
    System.out.println();
    System.out.println( "f( x) = " + ln);

// Ueberschrift
   System.out.println( "Berechne x = f( f^-1( x))");

// Exponentialfunktion
    Exp e = new Exp();

// Wertetabelle
    System.out.println();
    System.out.println
    ( "Bereich [ 0, 2], Schrittweite 0.25");

    for( double x = 0; x <= 2; x += 0.25)
    {
      System.out.println();
      System.out.println( x + ": ");

// Werteberechnung
      double y1 = ln.wert( x);
      double y2 = Math.log( x);
      double y3 = e.wert( y1);

// Ausgabe
      System.out.println
      ( "\tln.wert\t = " + y1);
      System.out.println
      ( "\tMath.log\t = " + y2);
      System.out.println
      ( "\te.wert( ln.wert( " + x + "))\t = " + y3);
    }

// Programm beendet
    System.out.println();
    System.out.println( "Test beendet");
  }
}

/* ----------------------------------------------------- */
                                          // Testergebnisse
/*
f( x) = ln( x)
Berechne x = f( f^-1( x))

Bereich [ 0, 2], Schrittweite 0.25

0.0: 
	ln.wert           	= -Infinity
	Math.log          	= -Infinity
	e.wert( ln.wert( 0.0))	= 0.0

0.25: 
	ln.wert           	= -1.3862943611198908
	Math.log          	= -1.3862943611198906
	e.wert( ln.wert( 0.25))	= 0.25

0.5: 
	ln.wert           	= -0.6931471805599454
	Math.log          	= -0.6931471805599453
	e.wert( ln.wert( 0.5))	= 0.5000000000000001

0.75: 
	ln.wert           	= -0.2876820724517808
	Math.log          	= -0.2876820724517809
	e.wert( ln.wert( 0.75))	= 0.75

1.0: 
	ln.wert           	= 0.0
	Math.log          	= 0.0
	e.wert( ln.wert( 1.0))	= 1.0

1.25: 
	ln.wert           	= 0.22314355131420993
	Math.log          	= 0.22314355131420976
	e.wert( ln.wert( 1.25))	= 1.25

1.5: 
	ln.wert           	= 0.4054651081081644
	Math.log          	= 0.4054651081081644
	e.wert( ln.wert( 1.5))	= 1.5000000000000002

1.75: 
	ln.wert           	= 0.5596157879354224
	Math.log          	= 0.5596157879354227
	e.wert( ln.wert( 1.75))	= 1.75

2.0: 
	ln.wert           	= 0.6931471805599452
	Math.log          	= 0.6931471805599453
	e.wert( ln.wert( 2.0))	= 1.9999999999999993

Test beendet
*/