// PowerTest.java                                   MM 2013

/**
 * Test der Klasse Power.
 * @author Monika Meiler
 */
public class PowerTest
{
/**
 * Berechnet die Funktion f( x) = a ^x fuer
 * gegebene x, vergleicht Ergebnis mit Math.pow( x).
 */
  public static void main( String[] args)
  {
// Neue Potenz
    Power pow = new Power();
    double a = 1.5;
    pow.setBasis( a);

// Funktionsausgabe
    System.out.println();
    System.out.println( "f( x) = " + pow);

// Wertetabelle
    System.out.println();
    System.out.println
    ( "Bereich [ -1, 1], Schrittweite 0.25");

    for( double x = -1; x <= 1; x += 0.25)
    {
      System.out.println();
      System.out.println( x + ": ");
      System.out.println
      ( "\tpow.wert      \t= " + pow.wert( x));
      System.out.println
      ( "\tMath.pow      \t= " + Math.pow( a, x));
    }

// Programm beendet
    System.out.println();
    System.out.println( "Test beendet");
  }
}

/* ----------------------------------------------------- */
                                          // Testergebnisse
/*
f( x) = 1.5 ^ x

Bereich [ -1, 1], Schrittweite 0.25

-1.0: 
	pow.wert      	= 0.6666666666666665
	Math.pow      	= 0.6666666666666666

-0.75: 
	pow.wert      	= 0.7377879464668812
	Math.pow      	= 0.7377879464668811

-0.5: 
	pow.wert      	= 0.8164965809277258
	Math.pow      	= 0.816496580927726

-0.25: 
	pow.wert      	= 0.9036020036098448
	Math.pow      	= 0.9036020036098449

0.0: 
	pow.wert      	= 1.0
	Math.pow      	= 1.0

0.25: 
	pow.wert      	= 1.1066819197003217
	Math.pow      	= 1.1066819197003217

0.5: 
	pow.wert      	= 1.2247448713915894
	Math.pow      	= 1.224744871391589

0.75: 
	pow.wert      	= 1.355403005414767
	Math.pow      	= 1.3554030054147672

1.0: 
	pow.wert      	= 1.5000000000000002
	Math.pow      	= 1.5

Test beendet
*/
