// WurzelTest.java                                  MM 2013

/**
 * Test der Klasse Wurzel.
 * @author Monika Meiler
 */
public class WurzelTest
{
/**
 * Berechnet die 2.Wurzel( x) im Intervall [ 0, 1]
 * mit der Schrittweite 0.25 und Grenzwerte,
 * vergleicht Ergebnis mit Math.sqrt( x).
 */
  public static void main( String[] args)
  {
// Neue Wurzel
    Wurzel wurzel = new Wurzel();
    wurzel.setWurzel( 2);

// Wurzelausgabe
    System.out.println();
    System.out.println( "f( x) = " + wurzel);

// Wertetabelle
    System.out.println();
    System.out.println
    ( "Intervall [ 0, 1], Schrittweite 0.25");

    double x;

    for( x = 0; x <= 1; x += 0.25)
    {
      System.out.println();
      System.out.println( "2. Wurzel( " + x + ")");
      System.out.println
      ( "\twurzel.wert   \t= " + wurzel.wert( x));
      System.out.println
      ( "\tMath.sqrt     \t= " + Math.sqrt( x));
    }

// Grenzwerte
    System.out.println();
    System.out.println( "Grenzwerte");

// x < 0
    x = -1;
    System.out.println();
    System.out.println( "2. Wurzel( " + x + ")");
    System.out.println
    ( "\twurzel.wert   \t= " + wurzel.wert( x));
    System.out.println
    ( "\tMath.sqrt     \t= " + Math.sqrt( x));

// x sehr gross
    x = Float.MAX_VALUE;
    System.out.println();
    System.out.println
    ( "2. Wurzel( " + x + ")   // Float.MAX_VALUE");
    System.out.println
    ( "\twurzel.wert   \t= " + wurzel.wert( x));
    System.out.println
    ( "\tMath.sqrt     \t= " + Math.sqrt( x));

    x = Double.MAX_VALUE;
    System.out.println();
    System.out.println
    ( "2. Wurzel( " + x + ")  // Double.MAX_VALUE");
    System.out.println
    ( "\twurzel.wert   \t= " + wurzel.wert( x));
    System.out.println
    ( "\tMath.sqrt     \t= " + Math.sqrt( x));

// Programm beendet
    System.out.println();
    System.out.println( "Test beendet");
  }
}

/* ----------------------------------------------------- */
                                          // Testergebnisse
/*
f( x) = 2. Wurzel( x)

Intervall [ 0, 1], Schrittweite 0.25

2. Wurzel( 0.0)
	wurzel.wert   	= 0.0
	Math.sqrt     	= 0.0

2. Wurzel von 0.25
	wurzel.wert   	= 0.5000000000000006
	Math.sqrt     	= 0.5

2. Wurzel( 0.5)
	wurzel.wert   	= 0.7071067811865476
	Math.sqrt     	= 0.7071067811865476

2. Wurzel( 0.75)
	wurzel.wert   	= 0.8660254037844386
	Math.sqrt     	= 0.8660254037844386

2. Wurzel( 1.0)
	wurzel.wert   	= 1.0
	Math.sqrt     	= 1.0

Grenzwerte

2. Wurzel( -1.0)
	wurzel.wert   	= NaN
	Math.sqrt     	= NaN

2. Wurzel( 3.4028234663852886E38)        // Float.MAX_VALUE
	wurzel.wert   	= 1.844674352395373E19
	Math.sqrt     	= 1.844674352395373E19

2. Wurzel( 1.7976931348623157E308)      // Double.MAX_VALUE
	wurzel.wert   	= NaN
	Math.sqrt     	= 1.3407807929942596E154

Test beendet
*/